---
title: Release 2021-07-16
menuTitle: 2021-07-16
any: true
description: >-
  Changelog for Release 2021-07-16 (oso 0.14.0) containing new features,
  bug fixes, and more.
draft: false
---

## `oso` 0.14.0

### Core

#### Breaking changes

{{% callout "Warning" "orange" %}}
  This release contains breaking changes. Be sure to follow migration steps
  before upgrading.
{{% /callout %}}

##### Singleton variables changed from warnings to errors

[Singleton variables](https://docs.osohq.com/reference/polar/polar-syntax.html#singletons) occur only once in a rule.
Oso now considers them an error unless they're explicitly marked with an underscore.

*Before:*

```polar
f(x, y, z) if y = z; # issues a warning for x
```

*After:*

```polar
# f(x, y, z) if y = z; # would cause a parse error

f(_x, y, z) if y = z; # write this instead!
```

#### New features

##### Custom query timeouts

Added the ability for users to configure query timeouts using a
`POLAR_TIMEOUT_MS` environment variable. To disable timeouts (which is useful
for debugging), set `POLAR_TIMEOUT_MS` to `0`.

### Ruby (`oso-oso`)

#### New features

##### Roles in Ruby

The Ruby library now has
built-in support for Role-Based Access Control (RBAC) policies, which
you can turn on with `OSO.enable_roles`.

#### Other bugs & improvements

- Oso's Ruby library now behaves better with code reloading in development. You
  can use `OSO.register_class(Klass)` and calls to `foo matches Klass` will
  always use the up-to-date version of the `Klass` constant, even if it's been
  reloaded.

### Java

#### Other bugs & improvements

- Initial work on bringing the `Expression` type to Java has been completed.
  Huge thanks to [`@MFAshby`](https://github.com/MFAshby)!

## `sqlalchemy-oso` 0.10.0

### Other bugs & improvements

- Thanks to [`@tomashozman`](https://github.com/tomashozman) for cleaning up
  some SQLAlchemy imports ([#997](https://github.com/osohq/oso/pull/997)).
