---
title: Release 2021-08-13
menuTitle: 2021-08-13
any: true
description: >-
  Changelog for Release 2021-08-13 (sqlalchemy-oso 0.11.0, django-oso 0.11.0, oso 0.15.0) containing new features,
  bug fixes, and more.
draft: false
---

## `oso` 0.15.0

### Core

#### Breaking changes

{{% callout "Warning" "orange" %}}
  This release contains breaking changes. Be sure to follow migration steps
  before upgrading.
{{% /callout %}}

- Changes to the query format affect ORM integrations. If you use one, be sure to update!

#### Other bugs & improvements

- Performance for large policies has been improved.
- Constraints applied to unbound variables no longer prevent the variables from becoming bound. For example:

```
parent_child(org: Org, repo: Repo) if org = repo.org;
```

will now work as expected when called with an unbound first argument; previously it was necessary to write

```
parent_child(org, repo: Repo) if org = repo.org and org matches Org;
```

to obtain the same behavior.

### Ruby

#### Other bugs & improvements

- The ruby host library now only calls `to_s` on external instances when the
  instance needs to be serialized for a log line, debug message, or error. This
  improves performance in cases where `to_s` is slow (i.e. requires a round-trip
  to the database).

## `django-oso` 0.11.0

#### Other bugs & improvements

- Minor updates to maintain compatibility with the core.

## `sqlalchemy-oso` 0.11.0

#### Other bugs & improvements

- Minor updates to maintain compatibility with the core.

## `flask-oso` 0.12.0

#### Other bugs & improvements

- Minor updates to maintain compatibility with the core.
